# $Id: apopfilter_ldap.rb,v 1.1 2003/12/18 06:08:09 tommy Exp $
#
# Copyright (C) 2003 TOMITA Masahiro
# tommy@tmtm.org
#

require "ldap"

$ldap_method = LDAP::LDAP_AUTH_SIMPLE
$ldap_scope = LDAP::LDAP_SCOPE_SUBTREE

class POPS
  def apop_auth(user, digest, apopkey)
    ldap = LDAP::Conn.new($ldap_server, $ldap_port)
    ldap.bind($ldap_dn, $ldap_passwd, $ldap_method) if $ldap_dn
    pw = nil
    filter = sprintf($ldap_filter, user)
    ldap.search($ldap_base, $ldap_scope, filter) do |e|
      pw = e.to_hash[$ldap_passwd_attribute][0]
      break
    end
    unless pw and digest == MD5::new(apopkey+pw).hexdigest then
      log_notice "authentication failed: #{user}"
      err "authentication failed"
      return nil
    end
    pw
  end
end
