# $Id: apopfilter_file.rb,v 1.1 2003/11/02 14:22:35 tommy Exp $
#
# Copyright (C) 2003 TOMITA Masahiro
# tommy@tmtm.org
#
require "dbm"
class POPS
  def apop_auth(user, digest, apopkey)
    pw = nil
    File::open($apop_passwd_file, "r") do |lock|
      lock.flock(File::LOCK_SH)
      pw = DBM::open($apop_passwd_file) {|dbm| dbm[user]}
    end
    unless pw and digest == MD5::new(apopkey+pw).hexdigest then
      log_notice "authentication failed: #{user}"
      err "authentication failed"
      return nil
    end
    pw
  end
end
